#ifndef _FENRIR_TYPES_H_
#define _FENRIR_TYPES_H_

#define FENEXP	__stdcall
typedef void*	LPFENRIR;
typedef enum
{
	EMM_NO_ERROR					=0,
	EMM_ERROR_INVALID_PTR			=-100,
	EMM_ERROR_PROVIDER_NOT_FOUND	=-101,
	EMM_ERROR_UNSUPPORTED_CA		=-200,
	EMM_ERROR_UNKNOWN_EMM			=-201,
	EMM_ERROR_NO_CAID1800			=-202,

	EMM_ERROR_IRD_FIRST				=-1000,
	EMM_ERROR_INVALID_IRD_KIDFILE	=-1001,
	EMM_ERROR_INVALID_IRD_KEYFILE	=-1002,
	EMM_ERROR_INVALID_IRD_PRVFILE	=-1003,
	EMM_ERROR_IRDETO_EMM_TOO_LONG	=-1010,
	EMM_ERROR_IRD_LAST				=-1099,

	EMM_ERROR_NAGRA_FIRST			=-1100,
	EMM_ERROR_INVALID_NAGRA_KIDFILE =-1101,
	EMM_ERROR_INVALID_NAGRA_KEYFILE =-1102,
	EMM_ERROR_INVALID_NAGRA_PATH	=-1103,
	EMM_ERROR_NAGRA_LAST			=-1199,

	EMM_ERROR_VIA_FIRST				=-1200,
	EMM_ERROR_INVALID_VIA_SCIFILE	=-1201,
	EMM_ERROR_INVALID_VIA_KEYFILE	=-1202,
	EMM_ERROR_INVALID_VIA_PRVFILE	=-1203,
	EMM_ERROR_VIA_LAST				=-1299,

	EMM_ERROR_CONAX_FIRST			=-1300,
	EMM_ERROR_INVALID_CONAX_KIDFILE	=-1301,
	EMM_ERROR_INVALID_CONAX_KEYFILE	=-1302,
	EMM_ERROR_CONAX_LAST			=-1399,

	EMM_ERROR_SECA_FIRST			=-1400,
	EMM_ERROR_INVALID_SECA_KIDFILE	=-1401,
	EMM_ERROR_INVALID_SECA_KEYFILE	=-1402,
	EMM_ERROR_INVALID_SECA_PRVFILE	=-1403,
	EMM_ERROR_SECA_LAST				=-1499

} EMM_ERRORS_t;

typedef enum
{
	FENRIR_CA_UNKNOWN	=-1, // Auto
	FENRIR_CA_SECA		=0x01,
	FENRIR_CA_VIACCESS	=0x05,
	FENRIR_CA_IRDETO	=0x06,
	FENRIR_CA_VIDEOGUARD=0x09,
	FENRIR_CA_CONAX		=0x0B,
	FENRIR_CA_CRYPTO	=0x0D,
	FENRIR_CA_POWERVU	=0x0E,
	FENRIR_CA_NAGRABEV	=0x12,
	FENRIR_CA_BETA		=0x17,
	FENRIR_CA_NAGRA		=0x18
} FENRIR_CA_MAJOR_TYPE_t;

typedef enum
{
	FENRIR_NOTIFY_FLAGS_KEY=8,
	FENRIR_NOTIFY_FLAGS_SA=16,
	FENRIR_NOTIFY_FLAGS_UA=32
} FENRIR_NOTIFY_FLAGS_t;

typedef union
{
	struct
	{
		unsigned int pid:13;
		unsigned int padding:3;
		unsigned int ca:8;
		unsigned int flags:8;
	};
	unsigned long val;
} fenrir_notify_t;


typedef int (__stdcall *EMM_Notify_Proc)(int id,const char *txt);
typedef unsigned char u8;
#endif